package flink.zanxiangnet.ad.monitoring.process;

import flink.zanxiangnet.ad.monitoring.pojo.entity.AdDataOfDayODS;
import flink.zanxiangnet.ad.monitoring.pojo.entity.PlanStatOfDayDWD;
import lombok.extern.slf4j.Slf4j;
import org.apache.flink.api.common.state.ValueState;
import org.apache.flink.api.common.state.ValueStateDescriptor;
import org.apache.flink.configuration.Configuration;
import org.apache.flink.streaming.api.functions.KeyedProcessFunction;
import org.apache.flink.util.Collector;

@Slf4j
public class PlanDayDWDRollYearProcess extends KeyedProcessFunction<Long, AdDataOfDayODS, PlanStatOfDayDWD> {

    // 上次聚合的结果
    private ValueState<PlanStatOfDayDWD> lastReduceState;

    public void open(Configuration conf) {
        lastReduceState = getRuntimeContext().getState(new ValueStateDescriptor<>("lastReduceState", PlanStatOfDayDWD.class));
    }

    @Override
    public void processElement(AdDataOfDayODS element, KeyedProcessFunction<Long, AdDataOfDayODS, PlanStatOfDayDWD>.Context context,
                               Collector<PlanStatOfDayDWD> collector) throws Exception {
        PlanStatOfDayDWD newStatDWD = PlanStatOfDayDWD.reduce(lastReduceState.value(), element, System.currentTimeMillis());
        collector.collect(newStatDWD);
        lastReduceState.update(newStatDWD);
    }
}
